#include "ContextCallLogDocument.h"
#include "ContextCallLogAppUi.h"
#include "settings.h"

#include "bb_settings.h"
#include "cl_settings.h"
#include "cbbsession.h"
#include "cc_schedulers.h"

CContextCallLogDocument::CContextCallLogDocument(CEikApplication& aApp)
: CAknDocument(aApp)    
    {
    }

CContextCallLogDocument::~CContextCallLogDocument()
{
}

// EPOC default constructor can leave.
void CContextCallLogDocument::ConstructL()
{
	MContextDocument::ConstructL(Application(),
		iNoDefaults, KCLSettingsTuple,
		_L("calllog.txt"), _L("call_log"));

#ifdef __WINS__
	iContext->SetAppDir(_L("c:\\system\\apps\\contextcalllog\\"));
#endif
}

CContextCallLogDocument* CContextCallLogDocument::NewL(CEikApplication& aApp)     
{
	CContextCallLogDocument* self = new (ELeave) CContextCallLogDocument( aApp );
	CleanupStack::PushL( self );
	self->ConstructL();
	CleanupStack::Pop();

	return self;
}

CEikAppUi* CContextCallLogDocument::CreateAppUiL()
    {
    return new (ELeave) CContextCallLogAppUi(*iContext);
    }


