/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


#ifndef CC_CHECKECACTIVE_H_INCLUDED
#define CC_CHECKECACTIVE_H_INCLUDED 1

#include <e32base.h>

class MApp_context;

class CCheckedActive : public CActive {
public:
	IMPORT_C ~CCheckedActive();
	IMPORT_C const TDesC& Name();
protected:
        IMPORT_C CCheckedActive(TInt aPriority, const TDesC& Name);
        IMPORT_C void SetActive();
	IMPORT_C virtual TInt CheckedRunError(TInt aError);
	virtual void CheckedRunL() = 0;
	HBufC* iLatestErrorStack;
private:
	IMPORT_C void RunL();
	IMPORT_C TInt RunError(TInt aError);
	TBuf<40> iName;
	MApp_context* iContext;

	friend class CDummy;
	TUint	iRunLCount;
	TInt64	iTotalTicks, iTotalSquaredTicks;
	TUint	iMaxTicks, iMinTicks;
	TInt*	iLive;
};

#endif
