/*
* ============================================================================
*  Name     : CContextNoteContainer from ContextNoteContainer.h
*  Part of  : ContextNote
*  Created  : 16.7.2004 by 
*  Description:
*     Declares container control for application.
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef CONTEXTNOTECONTAINER_H
#define CONTEXTNOTECONTAINER_H

// INCLUDES
#include <coecntrl.h>
#include <eikedwin.h>

// CLASS DECLARATION

/**
*  CContextNoteContainer  container control class.
*  
*/
class CContextNoteContainer : public CCoeControl, MCoeControlObserver, public MEikEdwinObserver
{
public: // Constructors and destructor
        
        /**
        * EPOC default constructor.
        * @param aRect Frame rectangle for container.
        */
        void ConstructL(const TRect& aRect);
	
        /**
        * Destructor.
        */
        ~CContextNoteContainer();
	
public: // New functions
	const TDesC& GetText();
	
public: // Functions from base classes
	
private: // Functions from base classes
	
	 /**
	 * From CoeControl,SizeChanged.
        */
        void SizeChanged();
	
	/**
        * From CoeControl,CountComponentControls.
        */
        TInt CountComponentControls() const;
	
	/**
        * From CCoeControl,ComponentControl.
        */
        CCoeControl* ComponentControl(TInt aIndex) const;
	
	/**
        * From CCoeControl,Draw.
        */
        void Draw(const TRect& aRect) const;
	
	/**
        * From ?base_class ?member_description
        */
        // event handling section
        // e.g Listbox events
        void HandleControlEventL(CCoeControl* aControl,TCoeEvent aEventType);
	
	TKeyResponse OfferKeyEventL(const TKeyEvent &aKeyEvent, TEventCode aType);
	void HandleEdwinEventL(CEikEdwin* aEdwin,TEdwinEvent aEventType);
        
private: //data
        
        CEikEdwin *iEdit;
	HBufC*	iBuf;
};

#endif

// End of File
