/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


#ifndef CB_DBLLINEBOX_H_INCLUDED
#define CB_DBLLINEBOX_H_INCLUDED

#include <aknlists.h>
#include <eikfrlbd.h> 
#include "phonebook.h"
#include "file_output_base.h"

class CPresenceModel : public CAknFilteredTextListBoxModel
{
public:
	IMPORT_C static CPresenceModel* NewL(MDesCArray* aNameArray, MDesCArray* aPresenceArray);
	IMPORT_C void SetFilter(CAknListBoxFilterItems * aFilter);
private:
	CPresenceModel(MDesCArray* aNameArray, MDesCArray* aPresenceArray);
	void ConstructL();
	virtual TPtrC ItemText(TInt aItemIndex) const;
	virtual TInt NumberOfItems() const;
	virtual const MDesCArray* MatchableTextArray() const;

	MDesCArray* iNameArray;
	MDesCArray* iPresenceArray;
	CAknListBoxFilterItems * iFilter;
};

class doublelinebox : public CEikFormattedCellListBox
{		
public:
	IMPORT_C doublelinebox(phonebook_i * aBook, Mfile_output_base * aLog);
	IMPORT_C void ConstructL(MDesCArray* aNameArray, MDesCArray* aPresenceArray, 
		const CCoeControl* aParent,TInt aFlags);
	IMPORT_C TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);
	IMPORT_C ~doublelinebox();
	IMPORT_C void LogVisibleItems(TInt currentItemIndex);
	
	virtual void SizeChanged();
	CPresenceModel *iPresenceModel;
	
private:
	void CreateItemDrawerL(void);
	void LogItem(const TDesC& item);

	TInt AddSubCell(class COptionalFormattedCellListBoxData* itemd,
		TMargins marg, TSize size, TPoint pos, TInt baselinepos, 
		CGraphicsContext::TTextAlign aAlign, TBool aGraphic=EFalse,
		TInt aGrowIndex=-1);
private:
	phonebook_i * book;
	Mfile_output_base * iLog;
	TBuf<800> iBuf;
	TInt iLastCurrentItemIndex;
	class COptionalFormattedCellListBoxData* itemd;
	
	TInt iCells, iOffset;

	friend class CContextContactsContainer;
	friend class CContextCallLogContainer;
	
};

#endif