#ifndef CONTEXT_UIDS_H_INCLUDED
#define CONTEXT_UIDS_H_INCLUDED 1
/*
 * UIDs for Context components
 *
 * *app.h files should include this, instead of
 * defining the value
 * NOTE: these values are automatically updated
 *	 in the pkg files by update_sis_versions.pl
 *	 but have to manually updated in *_common.mmp
 *
 * range 1: 0x101FBAD0 to 0x101FBAD3 - USED UP
 */
#include "context_uids.rh"

const TUid KUidcontextbook = { CONTEXT_UID_CONTEXTBOOK };
const TUid KUidcontext_log = { CONTEXT_UID_CONTEXT_LOG };
const TUid KUidcl_autostart = { CONTEXT_UID_CL_AUTOSTART };
const TUid KUidautostart = { CONTEXT_UID_CL_AUTOSTART };
const TUid KUidstarter = { CONTEXT_UID_STARTER };

/*
 * range 2: 0x10200C6B to 0x10200C6E - USED UP
 */
const TUid KUidcontextserver = { CONTEXT_UID_CONTEXTSERVER };
const TUid KUidcontextclient = { CONTEXT_UID_CONTEXTCLIENT };
const TUid KUidcontextcommon = { CONTEXT_UID_CONTEXTCOMMON };
const TUid KUidrecognizer = { CONTEXT_UID_RECOGNIZER };

/*
 * range 3: 0x10204B9C to 0x10204BAF
 */

const TUid KUiddbtest = { CONTEXT_UID_DBTEST };
const TUid KUidGnubox = { CONTEXT_UID_GNUBOX };
const TUid KUidContextNote = { CONTEXT_UID_CONTEXTNOTE };
const TUid KUidContextFetch = { CONTEXT_UID_CONTEXTFETCH };
const TUid KUidContext = { CONTEXT_UID_CONTEXT };
const TUid KUidTaskList = { CONTEXT_UID_TASKLIST };
const TUid KUidContextNotify = { CONTEXT_UID_CONTEXTNOTIFY };
const TUid KUidContextNotifyClient = { CONTEXT_UID_CONTEXTNOTIFYCLIENT };
const TUid KUidContextContacts = { CONTEXT_UID_CONTEXTCONTACTS };
const TUid KUidContextCallLog = { CONTEXT_UID_CONTEXTCALLLOG };
const TUid KUidBlackBoardData = { CONTEXT_UID_BLACKBOARDDATA };
const TUid KUidBlackBoardServer = { CONTEXT_UID_BLACKBOARDSERVER };

/*
 * range 4
 */

const TUid KUidBlackBoardClient = { CONTEXT_UID_BLACKBOARDCLIENT };
const TUid KUidBlackBoardFactory = { CONTEXT_UID_BLACKBOARDFACTORY };
const TUid KUidBlackBoardClientTest = { CONTEXT_UID_BLACKBOARDCLIENTTEST };
const TUid KUidBlackBoard = { CONTEXT_UID_BLACKBOARD };
const TUid KUidContextSensors = { CONTEXT_UID_CONTEXTSENSORS };
const TUid KUidContextSensorFactory = { CONTEXT_UID_SENSORDATAFACTORY };
const TUid KUidContextNetwork = { CONTEXT_UID_CONTEXTNETWORK };
const TUid KUidContextCommon2 = { CONTEXT_UID_CONTEXTCOMMON2 };
const TUid KUidContextMedia = { CONTEXT_UID_CONTEXTMEDIA };
const TUid KUidContextMediaData = { CONTEXT_UID_CONTEXTMEDIADATA };
const TUid KUidContextMediaFactory = { CONTEXT_UID_CONTEXTMEDIAFACTORY };
const TUid KUidContextMediaApp = { CONTEXT_UID_CONTEXTMEDIAAPP };
const TUid KUidContextSensorData = { CONTEXT_UID_CONTEXTSENSORDATA };
const TUid KUidContextUI = { CONTEXT_UID_CONTEXTUI };
const TUid KUidContextMediaUi = { CONTEXT_UID_CONTEXTMEDIAUI };
const TUid KUidContextFlickr = { CONTEXT_UID_CONTEXT_LOG };
const TUid KUidMeaning = { CONTEXT_UID_CONTEXT_LOG };


const TUid KUidContextMenu = {CONTEXT_UID_CONTEXTMENU };

const TUid KUidGsmAudio = { CONTEXT_UID_GSMAUDIO };
const TUid KUidGsmAudioTest = { CONTEXT_UID_GSMAUDIO_TEST };
/*
 * external
 */
const TUid KUidexpat = { 0x101FAE0C };


#endif
